/*Copyright 2011, 2013 Alexandros Chortaras

 This file is part of Rapid.

 Rapid is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 Rapid is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Rapid.  If not, see <http://www.gnu.org/licenses/>.*/

package edu.ntua.ivml.common.utils;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.Writer;
import java.nio.charset.Charset;

public class IOUtils {

    public static String readFileAsString(File file) throws java.io.IOException{
        StringBuffer fileData = new StringBuffer(1000);
        
        FileReader fr = new FileReader(file);
        BufferedReader reader = new BufferedReader(fr);
        char[] buf = new char[1024];
        int numRead=0;
        
        while((numRead=reader.read(buf)) != -1){
            String readData = String.valueOf(buf, 0, numRead);
            fileData.append(readData);
            buf = new char[1024];
        }
        
        reader.close();
        fr.close();
        
        return fileData.toString();
    }
    
    public static void writeStringToFile(File file, String content, Charset cs) throws IOException{
    
    	FileOutputStream fos = new FileOutputStream(file);
    	OutputStreamWriter osw = new OutputStreamWriter(fos, cs);
    	Writer out = new BufferedWriter(osw);

    	out.write(content);
    	out.close();
    	osw.close();
    	fos.close();
    }
    
    public static void copyfile(File src, File dest) throws IOException{
    	InputStream in = new FileInputStream(src);
    	  
    	OutputStream out = new FileOutputStream(dest);

    	byte[] buf = new byte[1024];
    	int len;
    	
    	while ((len = in.read(buf)) > 0) {
    		out.write(buf, 0, len);
    	}
    	
    	in.close();
    	out.close();
    }
}
