/*Copyright 2011, 2013 Alexandros Chortaras

 This file is part of Rapid.

 Rapid is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 Rapid is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Rapid.  If not, see <http://www.gnu.org/licenses/>.*/

package edu.ntua.ivml.qa.utils;

import java.io.PrintStream;
import java.text.NumberFormat;
import java.util.ArrayList;
import java.util.Collection;

import edu.ntua.ivml.common.lp.ClauseWrapper;

import edu.ntua.ivml.qa.lp.theory.LogicProgram;



public class Utils {

	private static void printObject(PrintStream out, int size, int i, Object s) {
		char[] max = (size + "").toCharArray();
		char[] number = (i + "").toCharArray();
		
		String r = "";
		for (int j = number.length; j < max.length; j++) {
			r += " ";
		}
		
		r += i;
		
		out.println(r + ": " + s);
	}
	
	public static void printObjectArrayList(PrintStream out, String title, Collection<?> set) {
		out.println("-------------------------------------------------------------");
		out.println(title);
		out.println("-------------------------------------------------------------");
		int i = 0;
		for (Object c : set) {
			printObject(out, set.size(), i++, c);
		}
		out.println("-------------------------------------------------------------");
		out.println();
	}	
	
	public static void printClauses(PrintStream out, String title, Collection<ClauseWrapper> set) {
		out.println("-------------------------------------------------------------");
		out.println(title);
		out.println("-------------------------------------------------------------");
		int i = 0;
		for (ClauseWrapper c : set) {
			printObject(out, set.size(), i++, c.getClause());
		}
		out.println("-------------------------------------------------------------");
		out.println();
	}	

	public static void printClauses(PrintStream out, String title, LogicProgram lp) {
		printObjectArrayList(out, title, lp.getClauses());
	}
	
	public static String printArray(boolean[] arr) {
		String s = "[";
		
		for (int i = 0; i < arr.length; i++) {
			if (i > 0) {
				s += ", ";
			}
			s += arr[i];
		}
		s += "]";
		
		return s;
	}
	
	public static String printArray(int[] arr) {
		String s = "[";
		
		for (int i = 0; i < arr.length; i++) {
			if (i > 0) {
				s += ", ";
			}
			s += arr[i];
		}
		s += "]";
		
		return s;
	}

	public static String printArray(Object[] arr) {
		String s = "[";
		
		for (int i = 0; i < arr.length; i++) {
			if (i > 0) {
				s += ", ";
			}
			s += arr[i].toString();
		}
		s += "]";
		
		return s;
	}	
	
	public static String printArray(double[] arr) {
		String s = "[";
		
		for (int i = 0; i < arr.length; i++) {
			if (i > 0) {
				s += ", ";
			}
			s += arr[i];
		}
		s += "]";
		
		return s;
	}	
	
	public static <T> boolean subsumesSome(ArrayList<? extends Collection<T>> list, Collection<T> set) {
		for (Collection<T> l : list) {
			if (set.containsAll(l)) {
				return true;
			}
		}
		
		return false;
	}
}
